
TRUE equ 1

vesa_msg db "Komputer ini tidak mendukung Vesa",0dh,0ah,0
vesa_msg2 db "Komputer ini mendukung VESA",0dh,0ah,0
vesa_msg3 db "Komputer ini tidak mendukung Resolusi yang anda inginkan",0dh,0ah,0
vesa_msg4 db " Komputer ini mendukung Resolusi yang anda inginkan",0dh,0ah,0
vesa_msg5 db " Tidak Didukung",0dh,0ah,0
vesa_msg6 db "Maaf persiapan VESA dikomputer ini gagal. Coba lagi untuk mencari mode yang sesuai",0dh,0ah,0
buffer db "XXXXXXXXXXX",0
lfb dd 0
vmode dd 0

resx dd 0
resy dd 0
phys_addr dd 0
offs_mem dd 0
vmem dd 0
vbpp dd 0

segPerLine dd 0
acc_mode dd 0

VgaInfoBlock    STRUC
    VbeSignature         db 4 dup (?)     ; VBE Signature 
    VbeVersion           dw 0200h         ; VBE Version 
    OemStringPtr         dd ?             ; Pointer to OEM String 
    Capabilities         db 4 dup (?)     ; Capabilities of graphics controller 
    VideoModePtr         dd ?             ; Pointer to VideoModeList 
    TotalMemory          dw ?             ; Number of 64kb memory blocks 
                                          ; Added for VBE 2.0 
    OemSoftwareRev       dw ?             ; VBE implementation Software revision 
    OemVendorNamePtr     dd ?             ; Pointer to Vendor Name String 
    OemProductNamePtr    dd ?             ; Pointer to Product Name String 
    OemProductRevPtr     dd ?             ; Pointer to Product Revision String 
    Reserved db 222      dup (?)          ; Reserved for VBE implementation scratch 
                                          ;   area 
    OemData db 256       dup (?)          ; Data Area for OEM Strings
VgaInfoBlock    ENDS

ModeInfoBlock   STRUC

; Mandatory information for all VBE revisions  

    ModeAttributes          dw ?         ; mode attributes 
    WinAAttributes          db ?         ; window A attributes 
    WinBAttributes          db ?         ; window B attributes 
    WinGranularity          dw ?         ; window granularity 
    WinSize                 dw ?         ; window size 
    WinASegment             dw ?         ; window A start segment 
    WinBSegment             dw ?         ; window B start segment 
    WinFuncPtr              dd ?         ; pointer to window function 
    BytesPerScanLine        dw ?         ; bytes per scan line 
      
            ; Mandatory information for VBE 1.2 and above  
    XResolution             dw ?         ; horizontal resolution in pixels or characters3 
    YResolution             dw ?         ; vertical resolution in pixels or characters 
    XCharSize               db ?         ; character cell width in pixels 
    YCharSize               db ?         ; character cell height in pixels 
    NumberOfPlanes          db ?         ; number of memory planes  
    BitsPerPixel            db ?         ; bits per pixel 
    NumberOfBanks           db ?         ; number of banks 
    MemoryModel             db ?         ; memory model type 
    BankSize                db ?         ; bank size in KB 
    NumberOfImagePages      db ?         ; number of images 
    Reserved                db 1         ; reserved for page function 
      
            ; Direct Color fields (required for direct/6 and YUV/7 memory models)  
    RedMaskSize             db ?         ; size of direct color red mask in bits 
    RedFieldPosition        db ?         ; bit position of lsb of red mask 
    GreenMaskSize           db ?         ; size of direct color green mask in bits 
    GreenFieldPosition      db ?         ; bit position of lsb of green mask 
    BlueMaskSize            db ?         ; size of direct color blue mask in bits 
    BlueFieldPosition       db ?         ; bit position of lsb of blue mask 
    RsvdMaskSize            db ?         ; size of direct color reserved mask in bits 
    RsvdFieldPosition       db ?         ; bit position of lsb of reserved mask 
    DirectColorModeInfo     db ?         ; direct color mode attributes 

            ; Mandatory information for VBE 2.0 and above  
    PhysBasePtr             dd ?         ; physical address for flat memory frame buffer 
    OffScreenMemOffset      dd ?         ; pointer to start of off screen memory 
    OffScreenMemSize        dw ?         ; amount of off screen memory in 1k units 
    _Reserved                db 206 dup (?)  ; remainder of ModeInfoBlock
ModeInfoBlock   ENDS

vga_info0		equ memory_layout 	+ 1024
vga_info1	 	equ vga_info0 		+ 512

.code

VesaInit proc
	LOCAL reg:com32sys_t
	
	mov eax,vga_info0
	mov byte ptr[eax+0],"V"
	mov byte ptr[eax+1],"B"
	mov byte ptr[eax+2],"E"
	mov byte ptr[eax+3],"2"
	mov ecx,eax
	and ecx,0Fh
	shr eax,4
	
	mov reg.eax_,4f00h
	mov reg.es_,ax
	mov reg.edi_,ecx
	invoke CallInterupt,addr reg,10h,addr reg
	
	mov eax,reg.eax_
	.if al!=4fh
		invoke PrintRel,addr vesa_msg
		xor eax,eax
		ret
	.else
		push eax
		invoke PrintRel,CADD("Komputer ini mendukung Vesa Status:")
		pop eax
		.if ah==00
			invoke PrintRel,CADD("Sukses. Lanjutkan.")
			invoke PrintRel,addr crg
		.elseif ah==01
			invoke PrintRel,CADD("Gagal menyetel Vesa")
			invoke PrintRel,addr crg
			xor eax,eax
			ret
		.elseif ah==2
			invoke PrintRel,CADD("Tidak mendukung karena salah setel hardware")
			invoke PrintRel,addr crg
			xor eax,eax
			ret
		.elseif ah==3
			invoke PrintRel,CADD("Fungsi tidak di video mode saat ini")
			invoke PrintRel,addr crg
			xor eax,eax
			ret
		.endif
	.endif
	
	mov ecx,vga_info0
	invoke Println,ecx,4
	mov ecx,vga_info0
	movzx ecx,[ecx].VgaInfoBlock.VbeVersion
	invoke dw2hex,ecx,base_buffer
	invoke Print,base_buffer
	
	invoke PrintRel,CADD(" OEM String: ")
	mov ecx,vga_info0
	mov ecx,[ecx].VgaInfoBlock.OemStringPtr
	movzx edx,cx
	shr ecx,12
	add ecx,edx
	invoke Print,ecx
	
	mov ecx,vga_info0
	mov ecx,[ecx].VgaInfoBlock.OemVendorNamePtr
	.if ecx!=0	
		invoke PrintRel,CADD(" Vendor Name: ")
		mov ecx,vga_info0
		mov ecx,[ecx].VgaInfoBlock.OemVendorNamePtr
		movzx edx,cx
		shr ecx,12
		add ecx,edx
		invoke Print,ecx
	.endif

	mov ecx,vga_info0
	mov ecx,[ecx].VgaInfoBlock.OemProductNamePtr
	.if ecx!=0		
		invoke PrintRel,CADD(" OemProductNamePtr: ")
		mov ecx,vga_info0
		mov ecx,[ecx].VgaInfoBlock.OemProductNamePtr
		movzx edx,cx
		shr ecx,12
		add ecx,edx
		invoke Print,ecx
	.endif

	mov ecx,vga_info0
	mov ecx,[ecx].VgaInfoBlock.OemProductRevPtr
	.if ecx!=0	
		invoke PrintRel,CADD(" OemProductRevPtr: ")
		mov ecx,vga_info0
		mov ecx,[ecx].VgaInfoBlock.OemProductRevPtr
		movzx edx,cx
		shr ecx,12
		add ecx,edx
		invoke Print,ecx
	.endif
	
	invoke PrintRel,addr crg
	mov ecx,vga_info0
	mov eax,dword ptr[ecx].VgaInfoBlock.Capabilities
	pushad
		invoke PrintRel,CADD("Kemampuan:")
		invoke PrintRel,addr crg
	popad
	pushad
		bt eax,0
		.if CARRY?
			invoke PrintRel,CADD("DAC Bisa untuk di nyalakan kedalam 8-bit mode.")
			invoke PrintRel,addr crg
		.endif
	popad
	pushad
		bt eax,1
		.if CARRY?
			invoke PrintRel,CADD("Tanpa VGA Controller.")
			invoke PrintRel,addr crg
		.endif
	popad
	pushad
		bt eax,2
		.if CARRY?
			invoke PrintRel,CADD("programmed DAC with blank bit (i.e. only during blanking interval)")
			invoke PrintRel,addr crg
		.endif
	popad
	pushad
		bt eax,3
		.if CARRY?
			bt eax,4
			.if CARRY?
				invoke PrintRel,CADD("(VBE v3.0)stereo signalling via external VESA stereo connector")
				invoke PrintRel,addr crg
			.else
				invoke PrintRel,CADD("(VBE v3.0)stereo signalling via VESA EVC connector")
				invoke PrintRel,addr crg
			.endif
		.else
			bt eax,4
			.if CARRY?
				invoke PrintRel,CADD("4  (VBE/AF v1.0P) must call EnableDirectAccess to access framebuff")
				invoke PrintRel,addr crg
			.endif
		
		.endif
	popad
	pushad
		bt eax,5
		.if CARRY?
			invoke PrintRel,CADD("programmed DAC with blank bit (i.e. only during blanking interval)")
			invoke PrintRel,addr crg
		.endif
	popad
	pushad
		movzx eax,[ecx].VgaInfoBlock.TotalMemory
		mov ecx,64*1024
		mul ecx
		push eax
			invoke PrintRel,CADD("Jumlah total Memory Video: ")
		pop eax
		invoke dw2a,eax,base_buffer
		invoke Print,base_buffer
		invoke PrintRel,addr crg
	popad
	
	mov ecx,vga_info0
	mov ecx,[ecx].VgaInfoBlock.VideoModePtr
	.if ecx!=0
		movzx edx,cx
		shr ecx,12
		add ecx,edx
		invoke LoadMem,addr acc_mode,ecx	
	.else
		invoke PrintRel,CADD("Maaf, Komputer ini tidak mempunya pointer ke alamat mode yang didukung")
	.endif

	
	
	invOke fLEA,addr crg
	invoke Print,eax
	
	mov eax,1
	
	
	ret
VesaInit endp

VesaSwapBuffer proc uses esi edi lpSrc:dword,lpDest:dword
	
	mov ecx,1024*768
	mov esi,lpSrc
	mov edi,lpDest
	loop_swp:
	cld
	lodsd
	stosd
	dec ecx
	jnz loop_swp
	
	ret
VesaSwapBuffer endp

VesaFindMode proc xRes:dword,yRes:dword,bpp:dword,lfbs:dword
	LOCAL reg:com32sys_t
	LOCAL mode:dword
	LOCAL vlfb:dword
	LOCAL flbs:dword
	LOCAL closest:dword
	
	invoke Println,vga_info0,4
	invoke PrintRel,CADD("Version ")
	mov ecx,vga_info0
	movzx eax,[ecx].VgaInfoBlock.VbeVersion
	invoke dw2hex,eax,base_buffer
	invoke Print,base_buffer
	invoke PrintRel,addr crg
	
	invoke StoreMem,addr acc_mode
	.if eax!=0
		xor ecx,ecx
		loop_support:
		movzx edx,word ptr[eax+ecx*2]
		mov mode,edx
		inc ecx
		cmp dx,-1
		jz done
		pushad
			mov eax,vga_info1
			mov ecx,eax
			and ecx,0Fh
			shr eax,4
			mov reg.eax_,4f01h
			mov reg.es_,ax
			mov reg.edi_,ecx
			mov ecx,mode
			mov reg.ecx_,ecx
			invoke CallInterupt,addr reg,10h,addr reg		
		popad
		pushad
			mov ecx,vga_info1
			movzx eax,[ecx].ModeInfoBlock.ModeAttributes
			bt AX, 7      ; Does this mode support a linear frame buffer?
			.if !CARRY?
			    .if lfbs==TRUE
			    	popad
				    jmp loop_support    
			    .endif
		    .else
			   push mode
			   pop closest
		    .endif
		    
		    mov ecx,vga_info1
			movzx eax,[ecx].ModeInfoBlock.ModeAttributes
			bt AX, 4      ; Does this mode a graphic mode?
			.if !CARRY?
			    popad
				jmp loop_support    
		    .else
			   push mode
			   pop closest
		    .endif
		    
		    mov ecx,vga_info1
			movzx eax,[ecx].ModeInfoBlock.BitsPerPixel
			cmp bpp,eax
			popad
			jnz loop_support
			pushad
			
			push mode
			pop closest
		    
		    mov ecx,vga_info1
			movzx eax,[ecx].ModeInfoBlock.XResolution
			cmp xRes,eax
			popad
			jnz loop_support
			pushad
			
			push mode
			pop closest
			
			mov ecx,vga_info1
			movzx eax,[ecx].ModeInfoBlock.YResolution
			cmp yRes,eax
			popad
			jnz loop_support
			
			push mode
			pop closest
		    
		    .if flbs==TRUE
			    or closest,4000h
		    .endif
		    invoke LoadMem,addr vmode,closest
		    
		    mov eax,vga_info1
			mov ecx,eax
			and ecx,0Fh
			shr eax,4
			mov reg.eax_,4f01h
			mov reg.es_,ax
			mov reg.edi_,ecx
			mov ecx,closest
			mov reg.ecx_,ecx
			invoke CallInterupt,addr reg,10h,addr reg	
			
		   	 mov eax,closest
		  	 ret
		done:
		
		mov eax,closest
		.if eax!=0FFFFh
			.if flbs==TRUE
			    or closest,4000h
		    .endif
		    invoke LoadMem,addr vmode,closest
		    pushad
				mov eax,vga_info1
				mov ecx,eax
				and ecx,0Fh
				shr eax,4
				mov reg.eax_,4f01h
				mov reg.es_,ax
				mov reg.edi_,ecx
				mov ecx,closest
				mov reg.ecx_,ecx
				invoke CallInterupt,addr reg,10h,addr reg		
			popad
		    mov eax,closest
		.endif
	.endif
	
	ret
VesaFindMode endp

VesaSetMode proc 
	LOCAL reg:com32sys_t
	
	invoke StoreMem,addr vmode
	
	.if eax!=0
		mov reg.eax_,4f02h
		invoke StoreMem,addr vmode
		mov reg.ebx_,eax
		invoke CallInterupt,addr reg,10h,addr reg
	.else
		invoke fLEA,addr vesa_msg6
		invoke Print,eax
	.endif

	
	
	ret
VesaSetMode endp

VesaFormatPixel proc uses esi edi r:dword,g:dword,b:dword
	LOCAL bpp:dword
			
	mov eax,vga_info1
	mov ecx,8
	sub cl,[eax].ModeInfoBlock.RedMaskSize
	shr r,cl
	mov ecx,8
	sub cl,[eax].ModeInfoBlock.GreenMaskSize
	shr g,cl
	mov ecx,8
	sub cl,[eax].ModeInfoBlock.BlueMaskSize
	shr b,cl
	
	mov cl,[eax].ModeInfoBlock.RedFieldPosition
	shl r,cl
	mov cl,[eax].ModeInfoBlock.GreenFieldPosition
	shl g,cl
	mov cl,[eax].ModeInfoBlock.BlueFieldPosition
	shl b,cl
	xor eax,eax
	or eax,r
	or eax,g
	or eax,b
	
	
	ret
VesaFormatPixel endp

VesaCalculateOffset proc uses esi edi x:dword,y:dword
	LOCAL b:dword
	LOCAL offs:dword
	
	mov ecx,vga_info1
	xor edx,edx
	movzx eax,[ecx].ModeInfoBlock.XResolution
	mul y
	add eax,x
	xor edx,edx
	movzx ecx,[ecx].ModeInfoBlock.BitsPerPixel
	shr ecx,3
	mul ecx
	mov ecx,vga_info1
	add eax,[ecx].ModeInfoBlock.PhysBasePtr
	
	ret
VesaCalculateOffset endp

VesaPlotPixel  proc uses esi edi x:dword,y:dword,r:dword,g:dword,b:dword
	LOCAL vlfb:dword
	LOCAL reg:com32sys_t
	LOCAL bpp,offs,pixel:dword
	
	invoke VesaFormatPixel,r,g,b
	mov pixel,eax
	
	invoke VesaCalculateOffset,x,y
	mov edi,eax
	
	mov ecx,vga_info1
	movzx ecx,[ecx].ModeInfoBlock.BitsPerPixel
	shr ecx,3
	mov eax,pixel
	loop_store_byte:
		cld
		stosb
		shr eax,8
	dec ecx
	jnz loop_store_byte
	
	ret
VesaPlotPixel endp

VesaClearScreen proc uses esi edi r:dword,g:dword,b:dword
	LOCAL pixel:dword
	LOCAL x,y:dword
	LOCAL xres,yres:dword
	
	invoke VesaFormatPixel,r,g,b
	mov pixel,eax
	
	mov ecx,vga_info1
	movzx eax,[ecx].ModeInfoBlock.XResolution
	movzx ecx,[ecx].ModeInfoBlock.YResolution
	mul ecx
	mov ecx,eax
	xor edx,edx
	loop_fill:
	push ecx
		push edx
			mov eax,vga_info1
			movzx ecx,[eax].ModeInfoBlock.BitsPerPixel
			shr ecx,3
			add edx,[eax].ModeInfoBlock.PhysBasePtr
			push ecx
				mov edi,edx
				mov eax,pixel
				loop_store_byte:
					cld
					stosb
					shr eax,8
				dec ecx
				jnz loop_store_byte
			pop ecx
		pop edx
		add edx,ecx
	pop ecx
	dec ecx
	jnz loop_fill
	
	invoke VesaFormatPixel,0,255,0
	mov pixel,eax
	mov ecx,vga_info1
	movzx ecx,[ecx].ModeInfoBlock.XResolution
	loop_test_plot:
	push ecx
		invoke VesaPlotPixel,ecx,100,r,g,b
	pop ecx
	dec ecx
	jnz loop_test_plot
	
	
	
	
	ret
VesaClearScreen endp